package lcsb.mapviewer.services.utils.gmap;

import com.google.gson.ExclusionStrategy;
import com.google.gson.FieldAttributes;

/**
 * This object imlements an exclusion strategy that forbides to serialize parent
 * objects. The main reason is to prevent cyclic serialization in a tree-like
 * structures.
 * 
 * @author Piotr Gawron
 * 
 */
public class GsonExclusionParentStrategy implements ExclusionStrategy {

	@Override
	public boolean shouldSkipClass(Class<?> arg0) {
		return false;
	}

	@Override
	public boolean shouldSkipField(FieldAttributes fa) {
		// String className = fa.getDeclaringClass().getName();
		String fieldName = fa.getName();

		return fieldName.equals("parent");

	}

}
