package lcsb.mapviewer.services.view;

import java.math.BigInteger;
import java.security.SecureRandom;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Random;

public class AuthenticationToken {
	private String	 id;
	private Calendar expires;

	public AuthenticationToken() {
		Random random = new SecureRandom();
		id = new BigInteger(130, random).toString(32);
		expires = Calendar.getInstance();
		expires.add(Calendar.HOUR, 2);
	}

	/**
	 * @return the id
	 * @see #id
	 */
	public String getId() {
		return id;
	}

	/**
	 * @return the expires
	 * @see #expires
	 */
	public Calendar getExpires() {
		return expires;
	}

	@Override
	public String toString() {
		return getId() + ", expirese: " + new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSSXXX").format(expires.getTime());
	}

}
