package lcsb.mapviewer.services.view;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;
import lcsb.mapviewer.model.Project;
import lcsb.mapviewer.model.map.layout.Layout;
import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.model.map.model.ModelFullIndexed;
import lcsb.mapviewer.model.map.model.ModelSubmodelConnection;
import lcsb.mapviewer.services.ServiceTestFunctions;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

public class LayoutViewFactoryTest extends ServiceTestFunctions {

	@Autowired
	LayoutViewFactory	layoutViewFactory;

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testCreateEmpty() throws Exception {
		try {
			Object object = layoutViewFactory.create(null);
			assertNotNull(object);
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testCreateGson() throws Exception {
		try {
			LayoutView object = layoutViewFactory.create(null);
			assertNotNull(layoutViewFactory.createGson(object));
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testGetProject() throws Exception {
		try {
			Layout layout = new Layout();
			Project project = layoutViewFactory.getProjectForLayout(layout);
			assertNull(project);
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testGetProject2() throws Exception {
		try {
			Project project = new Project();
			project.setProjectId("TES_T1_23");
			Layout layout = new Layout();
			Model md = new ModelFullIndexed(null);
			md.setProject(project);
			layout.setModel(md);
			Project project2 = layoutViewFactory.getProjectForLayout(layout);
			assertEquals(project, project2);
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	@Test
	public void testGetProject3() throws Exception {
		try {
			Project project = new Project();
			project.setProjectId("TES_T1_23");
			Layout toplayout = new Layout();
			Layout layout = new Layout();
			Model md = new ModelFullIndexed(null);
			md.setProject(project);

			Model submodel = new ModelFullIndexed(null);

			ModelSubmodelConnection msc = new ModelSubmodelConnection();
			msc.setParentModel(md);
			msc.setSubmodel(submodel);

			md.addSubmodelConnection(msc);

			layout.setModel(submodel);
			toplayout.addLayout(layout);
			toplayout.setModel(md);
			Project project2 = layoutViewFactory.getProjectForLayout(layout);
			assertEquals(project, project2);
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

}
